# -*- coding:Utf-8 -*-
# unscope_duel V.1.201p by DoCky (2012/07/27)
# ../addons/eventscripts/unscope_duel/unscope_duel.py


import es, spe, psyco, hudlib, langlib, weaponlib, popuplib, effectlib, playerlib, gamethread

psyco.full()

addon = es.AddonInfo()
addon.version = "1.201p"
addon.author = "DoCky"
addon.name = "unscope_duel"

version = es.ServerVar(addon.name, "", "by DoCky -")
version.set(addon.version)
version.makepublic()

cvWeapon = es.ServerVar("ud_weapon", "awp_knife", "unscope_duel: weapon(s) given to duelist")
cvHealth = es.ServerVar("ud_health", "100", "unscope_duel: player health at duel begining")
cvArmor = es.ServerVar("ud_armor", "100", "unscope_duel: player armor at duel begining")
cvBeam = es.ServerVar("ud_beam", "1", "unscope_duel: activate beam [0-1]")
cvTime = es.ServerVar("ud_time", "1", "unscope_duel: define time for battle [sec]")
cvKill = es.ServerVar("ud_kill", "1", "unscope_duel: kill duelist at end of allowed time [0-1]")
cvLast = es.ServerVar("ud_last", "1", "unscope_duel: give back player weapon at end of duel [0-1]")
cvDrop = es.ServerVar("ud_drop", "1", "unscope_duel: drop/remove unauthorized weapon when duel is running [0-1-2]")

attack2 = (1 << 11)
language = None
weapons = set()
voterun = False
status = False
timer = 0
duel = []


#############################
#  SYSTEM
def ticker():
    global timer
    # countdown
    if timer:
        timer -= 1
        # update hud
        hud.modline(0, "hud", {"timeleft" : str(timer)})
        for player in duel: hud.send(player.userid)
        # delay next tick
        gamethread.delayedname(1, "_ud-timer", ticker)
    # end the duel
    else: duelEnd()

class Player(object):
    def __init__(self, userid, userteam):
        # set default values
        if int(userteam) == 2: self.blue, self.red = 25, 255
        else: self.blue, self.red = 255, 25
        self.beamthread = "_ud-beamthread-" + str(userid)
        self.loopthread = "_ud-loopthread-" + str(userid)

        self.userid = int(userid)
        self.lastloc = 0
        self.radius = 40
        self.weapon = []
        self.loop = 0

    def __loop(self):
        # if the duel is running
        if status:
            # draw circle
            if self.loop < 20:
                #if not self.loop % 2: self.lastloc = es.getplayerlocation(self.userid)
                self.lastloc = es.getplayerlocation(self.userid)
                effectlib.drawCircle(
                    (self.lastloc[0], self.lastloc[1], self.lastloc[2] + 45), self.radius, steps = 50,
                    width = 2.2, endwidth = 2.2, seconds = .1, green = 25, red = self.red, blue = self.blue,
                    model = "sprites/laserbeam.vmt", halo = "sprites/laserbeam.vmt")
                # increment radius
                self.radius += 8
                self.loop += 1
                # delay next loop
                gamethread.delayedname(.06, self.loopthread, self.__loop)
            else: gamethread.delayedname(1, self.beamthread, self.beam)

    def init(self):
        # set player props
        es.setplayerprop(self.userid, "CCSPlayer.m_bHasHelmet", 1)
        es.setplayerprop(self.userid, "CCSPlayer.m_ArmorValue", cvArmor)
        es.setplayerprop(self.userid, "CBasePlayer.m_iHealth", cvHealth)
        # give weapons for the duel
        for weapon in weapons:
            es.server.insertcmd("es_xgive %s weapon_%s" % (self.userid, weapon))

    def beam(self):
        # set default values
        self.radius = 40
        self.loop = 0
        # init beacon effect
        self.__loop()
        # emit sound
        #es.emitsound("player", self.userid, "buttons/blip2.wav", 1.0, 0.8)

    def last(self):
        player = playerlib.getPlayer(self.userid)
        # save weapons and items of player
        self.weapon = [
            str(player.primary),
            str(player.secondary),
            int(player.he),
            int(player.fb),
            int(player.sg),
            int(player.nightvision),
            int(player.defuser),
            int(player.c4)]

    def give(self):
        # give primary and secondary weapon
        for slot in xrange(0, 2):
            if self.weapon[slot] != "0":
                es.server.insertcmd("es_xgive %s %s" % (self.userid, self.weapon[slot]))

        # give hegrenade
        if self.weapon[2]:
            es.server.insertcmd(
                "es_xgive %s weapon_hegrenade;" % self.userid +
                "es_xsetplayerprop %s CBasePlayer.localdata.m_iAmmo.011 %s" % (self.userid, self.weapon[2]))

        # give flashbang
        if self.weapon[3]:
            es.server.insertcmd(
                "es_xgive %s weapon_flashbang;" % self.userid +
                "es_xsetplayerprop %s CBasePlayer.localdata.m_iAmmo.012 %s" % (self.userid, self.weapon[3]))

        # give smokegrenade
        if self.weapon[4]:
            es.server.insertcmd(
                "es_xgive %s weapon_smokegrenade;" % self.userid +
                "es_xsetplayerprop %s CBasePlayer.localdata.m_iAmmo.013 %s" % (self.userid, self.weapon[4]))

        # give c4
        if self.weapon[7]:
            es.server.insertcmd("es_xgive %s weapon_c4" % self.userid)

        # give defuser and nightvision
        es.setplayerprop(self.userid, "CCSPlayer.m_bHasNightVision", self.weapon[5])
        es.setplayerprop(self.userid, "CCSPlayer.m_bHasDefuser", self.weapon[6])



#############################
#  DUELFUNC
def duelMenu(userid, index, popup):
    # if vote is running:
    if voterun:
        # if player accept the duel
        if index == 1: duel.append(Player(userid, es.getplayerteam(userid)))
        elif index == 2: hideMenu()
        # starts the duel if both players have accepted
        if len(duel) == 2: duelInit()

def duelInit():
    global status, timer
    # set default values
    status, timer = True, int(cvTime)
    # remove weapon at ground
    if int(cvDrop) == 2: weapon_remove()
    # start countdown
    if timer: ticker()


    # create player_weaponstrip entity
    es.server.insertcmd("es_xcreateentity player_weaponstrip")
    for player in duel:
        # remember last weapon
        if int(cvLast): player.last()
        # beacon player
        if int(cvBeam): player.beam()
        # strip player, give weapon, etc...
        es.server.insertcmd("es_xfire %s player_weaponstrip strip" % player.userid)
        gamethread.delayed(.1, player.init)
    # remove player_weaponstrip entity
    gamethread.delayed(.2, killEntity, "player_weaponstrip")

def duelEnd():
    global voterun, status, duel
    # cancel timer thread
    gamethread.cancelDelayed("_ud-timer")

    for player in duel[:]:
        # cancel beam threads
        gamethread.cancelDelayed(player.beamthread)
        gamethread.cancelDelayed(player.loopthread)

        # if player exists
        if es.exists("userid", player.userid):
            # hide player's hud
            hud.hide(player.userid)
        # else, remove player from list
        else: duel.remove(player)

    if status:
        # if player must be kill
        if int(cvKill):
            if not timer and int(cvTime):
                for player in duel: es.sexec(player.userid, "kill")

        # give previous weapon
        if int(cvLast):
            # create player_weaponstrip entity
            es.server.insertcmd("es_xcreateentity player_weaponstrip")
            for player in duel:
                 if not es.getplayerprop(player.userid, "CBasePlayer.pl.deadflag"):
                    # strip player
                    es.server.insertcmd("es_xfire %s player_weaponstrip strip" % player.userid)
                    gamethread.delayed(.1, player.give)
            # remove player_weaponstrip entity
            gamethread.delayed(.2, killEntity, "player_weaponstrip")

    # set default values
    voterun = False
    status = False
    duel = []


def getPlayer(userid):
    # return player's instance
    for player in duel:
        if player.userid == int(userid):
            return player

def killEntity(entity):
    # remove player_weaponstrip entity
    userid = es.getuserid()
    if userid: es.server.insertcmd("es_xfire %s %s kill;" % (userid, entity))

def weaponZoom(parameters):
    if status:
        ucmd = spe.makeObject("CUserCmd", parameters[0])
        if ucmd.buttons & attack2:
            ucmd.buttons &= ~attack2
    return (spe.HookAction.Continue, 0)

def hideMenu(): 
    menu.timeout("view", 1)
    for userid in es.getUseridList():
        if popuplib.isqueued("ud_menu", userid): menu.update(userid)
    gamethread.delayed(2, menu.timeout, ("view", 0))


#############################
#  EVENTS
def init():
    global language
    # clear weapon list
    weapons.clear()
    # exec cfg file
    es.mexec("unscope_duel/config.cfg")
    # create weapon list
    for item in str(cvWeapon).split(","): weapons.add(item.strip())
    # load language file
    language = langlib.Strings(es.ServerVar("eventscripts_gamedir") + "/cfg/unscope_duel/language.ini")

def player_death(event):
    userct = playerlib.getUseridList("#alive,#ct")
    usert = playerlib.getUseridList("#alive,#t")

    # if a duel can be submitted
    if len(userct) == 1 and len(usert) == 1:
        # check if last players are human
        if len(playerlib.getUseridList("#human,#alive")) == 2:
            global voterun
            voterun = True
            # then send menu
            menu.timeout("view", int(cvTime))
            menu.send(userct + usert)

        # debug msg (bot can't play without scope)
        else: es.dbgmsg(1, "unscope_duel: bots cannot use snipes without scope")

    # if a duel was running, end it
    elif status: duelEnd()

def item_pickup(event):
    # if a duel is running
    if status:
        # if player can't takes weapon
        if int(cvDrop):
            userid, item = event["userid"], event["item"]
            weapon = weaponlib.getWeapon(item)

            # check if item is an allowed weapon
            if weapon:
                if not item in weapons:
                    # drop it if it's not
                    es.sexec(userid, "use weapon_%s" % item)
                    es.cexec(userid, "drop")

def weapon_remove():
    # for all entities
    for index, entity in es.createentityindexlist().items():
        # if the current is a weapon
        if entity["classname"].startswith("weapon_"):
            # who have no owner
            if es.getindexprop(index, "CBaseCombatWeapon.m_hOwner") == -1:
                # set entityname name
                es.setentityname(index, "weapToKill")
        # kill all weapons
        killEntity("weapToKill")

def round_end(event):
    # round end...
    hideMenu()
    duelEnd()

def round_start(event):
    global voterun, status, duel
    # set default values
    voterun = False
    status = False
    duel = []

def es_map_start(event):
    # a new map start
    init()

def load():
    global menu, hud
    # initialize the system
    init()
    spe.parseINI("unscope_duel/sigs.ini")
    spe.parseTypesINI("unscope_duel/types.ini")
    # detour weaponZoom function
    spe.detourFunction("PlayerRunCommand", spe.HookType.Pre, weaponZoom)

    # create hud
    hud = hudlib.hinttextbox()
    hud.language("../cfg/unscope_duel/language.ini")
    hud.addline("hud")

    # create popup
    menu = popuplib.create("ud_menu")
    menu.addline(language["title"])
    menu.addline(language["yes"])
    menu.addline(language["no"])
    menu.addline(language["exit"])
    menu.menuselect = duelMenu

def unload():
    global status
    status = False
    # stop duel
    duelEnd()
    # delete hud and menu
    hud.kill()
    menu.delete()
    # undetour weaponZoom function
    spe.undetourFunction("PlayerRunCommand", spe.HookType.Pre, weaponZoom)

def player_disconnect(event):
    # if the duel is running
    if status:
        # end the duel if the player was fighting
        if getPlayer(event["userid"]): duelEnd()
